function varargout=P3R2F_keioGLMtest(fcn,varargin)
% POTATo : Research Mode 2nd-Level-Analysis Function "Average"

% == History ==
%  2011.01.26 : New! (for testing....)

%##########################################################################
% Launcher
%##########################################################################
if nargin==0, fcn='help'; end

switch fcn
	case {'createBasicInfo','CreateGUI',...
			'Activate','Suspend',...
			'MakeArgData','SetArgData',...
			'UpdateRequest',...
			'execute',...
			'InfoButton',...
			'sub_MakeFIR_Model',...
			'CallBack_cbxModelType',... %--- add mu
			'CallBack_ModelFileSelect',... %--- add mu
			'CallBack_MakeData','CallBack_CheckHRF','CallBack_FitToHRF'}
		if nargout,
			[varargout{1:nargout}] = feval(fcn, varargin{:});
		else
			feval(fcn, varargin{:});
		end
	case 'enableInfoButton'
		varargout{1}=false;
	case {'myhandles'}
		% for debug
		disp('Debug Path');
		disp(C__FILE__LINE__CHAR);
		if nargout,
			[varargout{1:nargout}] = feval(fcn, varargin{:});
		else
			feval(fcn, varargin{:});
		end
	otherwise
		error('Not Implemented Function : %s',fcn);
end


%##########################################################################
function basic_info=createBasicInfo()
% Get Basic-Info of this function
%##########################################################################
basic_info.name = 'keio-lscp GLM test';   % Display-Name
basic_info.ver  = 1.0;          % Version (double)
basic_info.fcn  = mfilename;    % Function-Name


%##########################################################################
% GUI Control
%##########################################################################

%==========================================================================
function tag=mytag(tag)
% Tool : make unique tagname.
%==========================================================================
tag=[tag '_' mfilename];

%==========================================================================
function hs=CreateGUI(hs)
% Create Related GUI
%==========================================================================
%----------------------
% Get GUI Position...
%----------------------
pf=get(hs.frm_R2nd_Function,'Position'); % GUI Range..
pp=get(hs.pop_R2nd_Function,'Position'); % GUI
iy=5; ix=10; % margin

sx1=pf(1)+ix; y=pp(2)-iy*2;
xsize  =pf(3)-2*ix;
xsizep2=xsize/2-ix/2;

%----------------------
% GUI
%----------------------
y=y-25;
%----------------------
%-- Button: MakeData
p=[pp(1)+190 y 150 25];
cbstr = [mfilename '(''CallBack_MakeData'',guidata(gcbo))'];
[hs, dummy, p] = sub_MakeGUI_Button(hs, 'MakeData', cbstr, 'Make data', p,[0 0]);

%----------------------
%-- GUIs: data select
p=[pp(1)+ix y-15 90 70];
dp1=[0 70];
dp2=[100 -70];
newHS=[];%- handle list of "Data select GUIs"

mstr={'Mean','Max','Median','none'};
% D [ file ch Kind Stim RegNum]

hs2.figure1 = hs.figure1;

[hs2, newHS(end+1:end+2), p] = sub_MakeGUI_Listbox(hs2, 'File', '1', 1, 'File', p, dp1);
[hs2, newHS(end+1:end+2), p] = sub_MakeGUI_Popupmenu(hs2, 'MethodFile', mstr, 1, '(method)', p, dp2);

[hs2, newHS(end+1:end+2), p] = sub_MakeGUI_Listbox(hs2, 'Channel', '1', 1, 'Channel', p, dp1);
[hs2, newHS(end+1:end+2), p] = sub_MakeGUI_Popupmenu(hs2, 'MethodChannel', mstr, 1, '(method)', p, dp2);

[hs2, newHS(end+1:end+2), p] = sub_MakeGUI_Popupmenu(hs2, 'Kind', ...
	'1', 1, '(Kind)', p, dp1/2);
[hs2, newHS(end+1:end+2), p] = sub_MakeGUI_Popupmenu(hs2, 'Stim', ...
	'1', 1, '(Plot Stim)', p, dp1*2/3);


%-- copy to hs
fnms = fieldnames(hs2);
for k=1:length(fnms)
	hs.(fnms{k}) = hs2.(fnms{k});
end

%----------------------
%-- Button: Check FIR
cbstr = [mfilename '(''CallBack_CheckHRF'')'];
p=[p(1) p(2) 80 20];
[hs, newHS(end+1), p] = sub_MakeGUI_Button(hs, 'CheckHRF', cbstr, 'Check FIR', p,[0 0]);


%----------------------
%-- Button: Fit to HRF
% p=[pp(1)+5 pp(2)-200 220 40]; %..[x0, y0, xwidth, ywidth] of Frame
% [hs, newHS(end+1:end+2), p] = sub_MakeGUI_Frame(hs, 'Frame', 'Fit to HRF', p, [10 25]);
p=[pp(1)+5 pp(2)-160 340 80];
[hs, newHS(end+1:end+2), p] = sub_MakeGUI_Frame(hs, 'Frame', 'Fit to HRF', p, [0 0]);
p=[p(1)+220 p(2)-60 50 20];
cbstr = [mfilename '(''CallBack_FitToHRF'',guidata(gcbo),1)'];
[hs, newHS(end+1), p] = sub_MakeGUI_Button(hs, 'FitToHRFCheck', cbstr, 'Check', p, [60 0]);
cbstr = [mfilename '(''CallBack_FitToHRF'',guidata(gcbo))'];
[hs, newHS(end+1), p] = sub_MakeGUI_Button(hs, 'FitToHRFSave', cbstr, 'Save', p, [0 0]);


%--------- add Model-Selection func.
p=[pp(1)+10 pp(2)-185 130 20];
%[hs, myCBXhnd] = sub_MakeGUI_Checkbox(hs, 'HRFType', 0, 'Use Model from file', p, [0 0]);
[hs, newHS(end+1)] = sub_MakeGUI_Checkbox(hs, 'HRFType', 0, 'Use Model from file', p, [0 0]);%--;
myCBXhnd = newHS(end);%--;

nhs2=[];
p=[p(1)+130 p(2)+10 150 30];
[hs, nhs2(end+1:end+2), p] = sub_MakeGUI_Editbox(hs, 'ModelFileName', ...
	'', 'Model data file name', p, [0 0]);
cbstr = [mfilename '(''CallBack_ModelFileSelect'')'];
p=[p(1)+150 p(2)-20 40 20];
[hs, nhs2(end+1), p] = sub_MakeGUI_Button(hs, 'ModelSelectBtn', ...
	cbstr, '...', p, [0 0]);

%--- add mu
p=[pp(1)+10 pp(2)-200 100 30];
[hs, newHS(end+1:end+2), p] = sub_MakeGUI_Editbox(hs, 'delayRange', ...
	'-2.0 10.0', 'delay range(s)', p, [0 0]);
%---

UD.hndSet1 = newHS;
UD.hndSet2 = nhs2;
set(nhs2,'visible','off');%--;
set(myCBXhnd,'UserData',UD, 'Callback',...
	[mfilename '(''CallBack_cbxModelType'',gco)']);
%----------

D.hndSet1=newHS;
D.hndSet2=nhs2;%--;
D.hndDataSelectListbox = hs2;
set(hs.(mytag('btn_MakeData')),'UserData', D);

% Save API Data
setappdata(hs.figure1,mfilename,{});


%==========================================================================
function [h, myhs]=myhandles(hs)
% My Handle List
%==========================================================================

fn=fieldnames(hs);
h=[];
for k=1:length(fn)
	if ~isempty(findstr(fn{k},mfilename))
		h(end+1)=hs.(fn{k});
		myhs.(fn{k}) = hs.(fn{k});
	end
end


%==========================================================================
function h=Activate(hs)
% My GUI Visible On
%==========================================================================
h=myhandles(hs);

% % %##for debug###################
% try delete(h);catch;end
% hs=CreateGUI(hs);
% guidata(hs.figure1,hs);
% [h myhs]=myhandles(hs);
% % %#############################

set(h,'Visible','on');

D=get(hs.(mytag('btn_MakeData')),'UserData');
if ~isfield(D,'ResultMatrix')
	set(D.hndSet1,'visible','off');
end

hndl_cbx=findobj(D.hndSet1,'tag','cbx_HRFType_P3R2F_keioGLMtest');
set(hndl_cbx,'value',0);%--; check box off at start

% Activate API's
apidata=getappdata(hs.figure1,mfilename);
for ii=1:length(apidata)
	try
		feval(apidata{ii}.fcn,'Activate',hs,apidata{ii});
	catch
	end
end


%==========================================================================
function h=Suspend(hs)
% My GUI Visible Off
%==========================================================================
h=myhandles(hs);
set(h,'Visible','off');
% Suspend API's
apidata=getappdata(hs.figure1,mfilename);
for ii=1:length(apidata)
	try
		feval(apidata{ii}.fcn,'Suspend',hs,apidata{ii});
	catch
	end
end



%##########################################################################
% GUI Callbacks
%##########################################################################

%==========================================================================
function CallBack_cbxModelType(hObject)
%==========================================================================
v=get(hObject,'Value');
hs=get(hObject,'UserData');
if v==0
	set(hs.hndSet1,'visible','on');
	set(hs.hndSet2,'visible','off');
else
	% 	set(hs.hndSet1,'visible','off');
	%--- add mu
	set(hs.hndSet1,'visible','on');
	%---
	set(hs.hndSet2,'visible','on');
end

%==========================================================================
function CallBack_ModelFileSelect
%==========================================================================
d=guidata(gcf);
fpt=which('keioGLM_HRF32s.mat');
pt=fileparts(fpt);%- default path
while 1
	[f p]=uigetfile([pt '\*.mat'],'Select a model data file');
	if  isequal(f,0) || isequal(p,0), return;end
	try
		load([p f])
		figure;clf;
		plot(Model.HRF);
		break;
	catch
		errordlg('Can''t read Model data');
		break; %.. add 2011/06/21
	end
end
set(d.(mytag('edt_ModelFileName')), 'String',[p f]);


%==========================================================================
function CallBack_CheckHRF
%==========================================================================
hs=guihandles(gcf);

% selRes = sub_SelectDataByUserSelection(hs,'Draw','YES'); %- data select
[selRes, selDim] = sub_SelectDataByUserSelection(hs,'Draw','YES'); %- data select

assignin('base','r',selRes);

%D.SelectedData = selRes;
%set(hs.(mytag('btn_MakeData')),'UserData',D);


%==========================================================================
function CallBack_FitToHRF(hs,varargin)
%==========================================================================
D=get(hs.(mytag('btn_MakeData')),'UserData');
AD = D.ExeData.AD;
timeReso = AD.samplingperiod/1000;
dur = str2double(AD.taskDuration)/timeReso; %.. point
str_stim = unique(D.DataTags.Stim);

maxdelay = str2num(get(hs.(mytag('edt_delayRange')),'String'));
mindelay = maxdelay(1,1) * 1000 / AD.samplingperiod;
maxdelay = maxdelay(1,2) * 1000 / AD.samplingperiod;

%--- default HRF model
if get(hs.(mytag('cbx_HRFType')),'Value')
	load(get(hs.(mytag('edt_ModelFileName')), 'String'));
	m_HRF0 = Model.HRF;
	
else
	%     p = [6 16 1 1 6 0 32];
	p = [6 16 1 1 6 str2double(AD.blkpre_sec) 32];
	%	p(1) - delay of response (relative to onset)	   6
	%	p(2) - delay of undershoot (relative to onset)    16
	%	p(3) - dispersion of response			   1
	%	p(4) - dispersion of undershoot			   1
	%	p(5) - ratio of response to undershoot		   6
	%	p(6) - onset (seconds)				   0
	%	p(7) - length of kernel (seconds)		  32
	m_HRF0 = spm_hrf(timeReso,p);
end

% dur = 1; %... none convolution %<<=====================
dur = round(1 * dur); %<<=====================
m_HRF = conv(m_HRF0, ones(1,dur)/dur);
m_HRF = m_HRF(1:length(m_HRF0));

m_polar = 1; %<<=====================
m_HRF = m_polar * m_HRF;
%---

%--- FIR model
% selRes = sub_SelectDataByUserSelection(hs); %- data select
M = sub_MakeFIR_Model(AD); %.. M <RegressionN x pointN>
pointN = size(M,2);
% MW = M'*selRes; %.. MW <stimN x pointN>

%--- add mu
[selRes, selDim] = sub_SelectDataByUserSelection(hs); %- data select
[fileNDIM, chNDIM, kindNDIM, stimNDIM, regNDIM] = size(selRes);
tg = selDim{1,3};
indx_stim = tg{4};

MW = NaN * ones(fileNDIM, chNDIM, kindNDIM, stimNDIM, pointN);

for i=1:fileNDIM
	for j=1:chNDIM
		for k=1:kindNDIM
			for l=1:stimNDIM
				MW(i,j,k,l,:) = squeeze(selRes(i,j,k,l,:))'*M;
			end
		end
	end
end
%---

%====== seek optimal delay ======

Tau = NaN * ones(fileNDIM, chNDIM, kindNDIM, stimNDIM);
Maxc = NaN * ones(fileNDIM, chNDIM, kindNDIM, stimNDIM);

for i = 1 : fileNDIM
	for j = 1 : chNDIM
		for k = 1 : kindNDIM
			for l = 1 : stimNDIM
				tmpMW = squeeze(MW(i,j,k,l,:));
				maxlag = max([abs(mindelay) abs(maxdelay)]);
				if length(tmpMW) > length(m_HRF)
					[C,L] = xcorr(tmpMW(1:length(m_HRF)), m_HRF, maxlag, 'coeff');
				else
					[C,L] = xcorr(tmpMW, m_HRF(1:length(tmpMW)), maxlag, 'coeff');
				end
				indx = intersect(find(L >= mindelay), find(L <= maxdelay));
				C = C(indx);
				L = L(indx);
				[tmp, tg] = max(abs(C)); %.. HRF & FIR absolute max correlation
				%     [tmp, tg] = max(C); %.. HRF & FIR max positive correlation '<<======
				Maxc(i,j,k,l) = C(tg);
				Tau(i,j,k,l) = L(tg)*timeReso; %.. (sec)
				amp = max(abs(m_HRF));
				tmpMW = tmpMW-tmpMW(1);
				MW(i,j,k,l,:) = amp * (tmpMW / max(abs(tmpMW)));
			end
		end
	end
end


%====== Draw figures || Save data

if nargin == 2
	%%%%%%%% [[[ Check button mode ]]] %%%%%%%%
	
	if fileNDIM == 1 && chNDIM == 1 && kindNDIM == 1
		for kStim=1:stimNDIM
		figure;
		subplot(2,2,1:2);
		
		tmpMW = squeeze(MW(1,1,1,kStim,:));
		tmpTau = Tau(1,1,1,kStim);
		tmpMaxc = Maxc(1,1,1,kStim);
		
		plot([1:length(tmpMW)]*timeReso, tmpMW, 'k');hold on;
		plot([1:length(m_HRF)]*timeReso, m_HRF,'k:');
		plot([1:length(m_HRF)]*timeReso+tmpTau, m_HRF,'r:');
		title(strcat('Model comparison,  ', str_stim{kStim}));
		ylabel('a.u.');
		xlabel('time (sec)');
		legend({'FIR', 'fMRI HRF', 'fitted fMRI HRF'});
		
		subplot(2,2,3);
		t1=max([1 tg-10]);
		t2=min([tg+10 length(C)]);
		plot(L(t1:t2)*timeReso,C(t1:t2),'k.');hold on
		plot([tmpTau tmpTau],ylim,'k');
		xlabel('Delay time (sec)');ylabel('corr. coef.')
		title(sprintf('Correlation function\n[Peak time %0.2f (sec),  r = %0.2f]',tmpTau, tmpMaxc));
		
		subplot(2,2,4);hold on;
		plot([1:length(m_HRF0)]*timeReso,m_HRF0);
		plot([0 str2double(AD.taskDuration)],[0 0],'b','linewidth',3);
		plot([1:length(m_HRF)]*timeReso, m_HRF,'k:');
		legend({'fMRI-HRF','Task duration','convolved HRF'})
		xlabel('sec');ylabel('a.u.');title('');
		end
		
	end
	
else
	
	%%%%%%% [[[ Save button mode ]]] %%%%%%%%
	
	Model.HRF = m_HRF; %.. data of the original HRF wave
	Model.Tau = Tau;
	Model.maxcorr = Maxc;
	Model.selDim = selDim;
	Model.HbKind = AD.selectHbKind;
	Model.params = AD;
	Model.timeReso = timeReso;
	Model.sapmlingperiod = AD.samplingperiod;
	[f p] = uiputfile('*.mat','Save Model data');
	save([p f],'Model');
	
end


%##################################
%## Sub routine
%##################################

%==========================================================================
function M = sub_MakeFIR_Model(AD)
%==========================================================================

PRE = str2double(AD.blkpre_sec); %- sec
PST = str2double(AD.blkpost_sec);
BXW = str2double(AD.boxwidth_sec);
BXS = str2double(AD.boxshift_sec);

regN = str2num(AD.regN);

DUR = PRE + BXW + BXS * regN;
% DUR = 0 + BXW + BXS * (regN -1);

SMP = fix(1000/AD.samplingperiod);

pRE = fix(PRE * SMP); %.. point
pST = fix(PST * SMP);
bXW = fix(BXW * SMP);
bXS = fix(BXS * SMP);
dUR = fix(DUR * SMP);

%.. make model: M
M = zeros(regN,dUR);
st = 1 + pRE;
% st = 1;
for k=1:regN
	M(k, st:st+bXW-1) = 1;
	st = st + bXS;
end


%==========================================================================
% function selRes = sub_SelectDataByUserSelection(hs,varargin)
function [selRes, selDim] = sub_SelectDataByUserSelection(hs,varargin)
%==========================================================================
if nargin>1
	switch lower(varargin{1})
		case 'draw'
			flag_draw = 1;
	end
end

D=get(hs.(mytag('btn_MakeData')),'UserData');

%*** undefined bug ***
if iscell(D)
	D=D{1};
end
%*********************

%--- get averaging data range
hndstr = {'File','Channel','Kind','Stim'};
hndLbx = zeros(1,length(hndstr));
for k=1:length(hndstr)
	% 	hndLbx(k) = D.hndDataSelectListbox.(mytag(['lbx_' hndstr{k}]));
	%   tg{k}=get(hndLbx(k),'Value');
	%--- add mu
	if strcmp(hndstr{k}, 'File') || strcmp(hndstr{k}, 'Channel')
		hndLbx(k) = D.hndDataSelectListbox.(mytag(['lbx_' hndstr{k}]));
		tg{k}=get(hndLbx(k),'Value');
	elseif strcmp(hndstr{k}, 'Kind')
		tg{k}=D.ExeData.AD.selectHbKind;
	else %..Stim
		hndLbx(k) = D.hndDataSelectListbox.(mytag(['ppm_' hndstr{k}]));
		tmpv=get(hs.(mytag(['ppm_' hndstr{k}])),'Value');
		tmps=get(hs.(mytag(['ppm_' hndstr{k}])),'String');
		if strcmp(tmps{tmpv}, 'All')
			tg{k}=1:tmpv-1;
		else
			tg{k}=tmpv;
		end
	end
	%---
end

%--- make selected data  :  ResultMatrix [ file  ch  kind  Stim  RegNum]
% selRes = D.ResultMatrix(tg{1},tg{2},tg{3},tg{4},:);
selRes = D.ResultMatrix(tg{1},tg{2},1,tg{4},:);

%--- get averaging method (mean, max, median, none)
methID = zeros(1,length(hndstr));
for k=1:length(hndstr)
	% 	methID(k) = get( D.hndDataSelectListbox.(mytag(['ppm_Method' hndstr{k}])), 'Value');
	%--- add mu
	if strcmp(hndstr{k}, 'File') || strcmp(hndstr{k}, 'Channel')
		methID(k) = get( D.hndDataSelectListbox.(mytag(['ppm_Method' hndstr{k}])), 'Value');
	else
		methID(k) = 4; %.. not average
	end
	%---
end

selDim = cell(1,3);
selDim{1,1} = [hndstr 'Reg'];
tmp = zeros(1, length(selDim{1,1}));
for k=1:length(hndstr)
	if methID(k) < 4 %.. selected method(mean, max, or median)
		tmp(1,k) = 1;
	else %.. selected method(none)
		tmp(1,k) = length(tg{k});
	end
end
tmp(1,5) = size(selRes, length(size(selRes)));
selDim{1,2} = tmp;
selDim{1,3} = tg;

%--- get Unaveraged Dimension
% pDimList=[1 3 2 4];
% pTG=get(hs.(mytag('ppm_AveDim')),'Value');
% %**** unkown bug ****
% if iscell(pTG)
% 	pTG=pTG{1};
% end
% %*******************
% pDim = pDimList(pTG);
%--- add mu
% for k = find([1:length(hndstr)]~=pDim)
for k = 1 : length(hndstr)
	switch methID(k)
		case 1
			selRes=nanmean(selRes,k);
		case 2
			selRes=nanmax(selRes,[],k);
		case 3
			selRes=nanmedian(selRes,k);
			%--- add mu
		case 4
			% do not average
			%----
	end
end

selResFig = squeeze(selRes);


%-- draw figure -------------------------------------
if exist('flag_draw','var') && (flag_draw==1)
	
	%     hf=figure;
	% 	plot(selRes','o-');
	% 	%-legend
	% 	tmpStr = get(hndLbx(pDim),'String');
	% 	if ~iscell(tmpStr)
	% 		tmp=tmpStr;tmpStr={};
	% 		for k=1:size(tmp,1)
	% 			tmpStr{k} = tmp(k,:);
	% 		end
	% 	end
	% 	tmpStr = strrep(tmpStr,'_',' ');
	% 	legend(tmpStr{get(hndLbx(pDim),'Value')});
	%
	% 	h=datacursormode(hf);
	% 	set(h,'Enable','On','DisplayStyle','window');
	
	%--- add mu
	hf=figure;
	
	if length(size(selResFig)) == 2
		%.. When selRes dimension = 2, legend<-- stim
		plot(selResFig','o-');
		%- legend
		tmpStr = get(hndLbx(4),'String');
		if ~iscell(tmpStr)
			tmp=tmpStr;
			tmpStr={};
			for k=1:size(tmp,1)
				tmpStr{k} = tmp(k,:);
			end
		end
		tmpStr = strrep(tmpStr(tg{4}),'_',' ');
		legend(tmpStr);
	elseif length(size(selResFig)) == 3
		%.. When selRes dimension = 3, legend<-- file or ch, window<-- stim
		stimN = length(tg{4});
		for tmpstm=1:stimN
			subplot(1,stimN,tmpstm);
			plot(squeeze(selResFig(:,tmpstm,:))','o-');
		end
		%-legend
		indx=find(methID(1:2)==4); %.. none-type method in file or ch
		tmpStr = get(hndLbx(indx),'String');
		if ~iscell(tmpStr)
			tmp=tmpStr;
			tmpStr={};
			for k=1:size(tmp,1)
				tmpStr{k} = tmp(k,:);
			end
		end
		tmpStr = strrep(tmpStr,'_',' ');
		legend(tmpStr);
	else
		%.. When selRes dimension = 4, draw nothing : error
	end
	
	h=datacursormode(hf);
	set(h,'Enable','On','DisplayStyle','window');
	
end
%--------------------------------------------------



%##########################################################################
% GUI <--> ExeData
%##########################################################################

%==========================================================================
function ArgData=MakeArgData(hs)
% Get Parameter's of 1st-Level-Analysis Execution
%==========================================================================

% Average Or Mean
%ArgData.isMax=get(hs.(mytag('rdb_max')),'Value');

%- GUI handles
D=get(hs.(mytag('btn_MakeData')),'UserData');
ArgData.D=D(1:2:end);%- select listbox only
ArgData.D.hnd_MakeData = hs.(mytag('btn_MakeData'));

% API-Information
apidata=getappdata(hs.figure1,mfilename);
ArgData.APIInfo.Number=length(apidata);
ArgData.APIInfo.Stat  =cell([1,length(apidata)]);

for ii=1:length(apidata)
	api.fcn=apidata{ii}.fcn;
	api.fld=[apidata{ii}.fcn num2str(ii)];
	try
		ArgData.(api.fld)=feval(api.fcn,'MakeArgData',apidata{ii});
		api.isok  =true;
	catch
		api.isok  =false;
	end
	ArgData.APIInfo.Stat{ii}=api;
end

%==========================================================================
function r=SetArgData(hs,ArgData)
% Set Parameter's of 1st-Level-Analysis Execution
%==========================================================================
r=0;
%- data
D=get(hs.(mytag('btn_MakeData')),'UserData');
D.ResultMatrix = ArgData.D.ResultMatrix;
D.Header1 = ArgData.D.Header1;
D.ExeData = ArgData.D.ExeData;
set(hs.(mytag('btn_MakeData')),'UserData',D);

sub_Update_DataParmGUIs(ArgData);

% API-Information
apidata=getappdata(hs.figure1,mfilename);
for ii=1:length(apidata)
	try
		feval(apidata{ii}.fcn,'SetArgData',apidata{ii},...
			ArgData.([apidata{ii}.fcn num2str(ii)]));
	catch
		r=2;
	end
end


%##########################################################################
% Execution
%##########################################################################

%==========================================================================
function cellSS=UpdateRequest(hs,tag,varargin)
%==========================================================================
apidata=getappdata(hs.figure1,mfilename);
switch lower(tag)
	case 'init'
		% for init
		cellSS=varargin{1};
		for ii=1:length(apidata)
			try
				feval(apidata{ii}.fcn,'UpdateRequest',apidata{ii},cellSS);
			catch
			end
		end
		
		%- reset MakeData
		set(hs.(mytag('btn_MakeData')),'visible','on','String','Make Data','enable','on');
		D=get(hs.(mytag('btn_MakeData')),'UserData');
		set(D.hndSet1,'visible','off');
		set(D.hndSet2,'visible','off');%--;
		set(D.hndDataSelectListbox,'String','');
		if isfield(D,'ResultMatrix')
			D=rmfield(D,'ResultMatrix');
		end
		set(hs.(mytag('btn_MakeData')),'UserData',D);
		%-----------------
		
		
	case 'output'
		% for Output
		cellSS=varargin{1};
		for ii=1:length(apidata)
			try
				cellSS=feval(apidata{ii}.fcn,'UpdateRequest',apidata{ii},cellSS);
			catch
			end
		end
	otherwise
		error('Unknown tag');
end

%==========================================================================
function CallBack_MakeData(hs)
% Execute button
%   1. make Arguments
%   2. Execute
%==========================================================================
set(hs.(mytag('btn_MakeData')),'String','> making data ...','enable','off');
drawnow;
ArgData=MakeArgData(hs);  % get Argument from GUI
cellSS=P3_gui_Research_2nd('loadCellSS',hs);
r=execute(cellSS,ArgData);   % GUI-Independent functin..

set(hs.(mytag('btn_MakeData')),'visible','off');

if (r.error)
	errordlg(r.error,'T-Test Error');
end

%==========================================================================
function result=execute(cellSS, ArgData)
% Perform T-Test
% Input : cellSS={datar,...} : cell of Summarized Statistics
%       datar: Real-part of Summarized Statistics.
%       datar.nfile    : --(undefined here.)--
%       datar.Anafiles : --(undefined here.)--
%       datar.ExeData  : --(undefined here.)--
%       datar.Header        : Cell Header of Summarized Data
%       datar.SummarizedKey : Cell Summarized Data (Key-part)
%       datar.SummarizedData: Cell Summarized Data (Data-part)
%==========================================================================
result.error='';
%---------------------
% Input param check
%          or Setting
%---------------------
if isempty(cellSS)
	warndlg('Select and Add SS-Data.');
	return;
end

%isMax=ArgData.isMax;

%---------------------
% Make first-group
%---------------------
Dtg.filename = cellSS{1}.SummarizedKey(:,strmatch('filename',cellSS{1}.Header,'exact'));
Dtg.Stim = cellSS{1}.SummarizedKey(:,strmatch('Stim',cellSS{1}.Header,'exact'));
Dtg.RegNum = cellSS{1}.SummarizedKey(:,strmatch('Reg_Number',cellSS{1}.Header,'exact'));

[DtgIDX, szs] = sub_DtgValue2DtgIDX(Dtg);

n_channel = size(cellSS{1}.SummarizedData{1},2);
n_kind = size(cellSS{1}.SummarizedData{1},3);

Dat = zeros(szs(1), n_channel, n_kind, szs(2), szs(3));
for k0 = 1:size(cellSS{1}.SummarizedData,1) %- data loop
	Dat(DtgIDX.filename(k0), :, :,DtgIDX.Stim(k0), DtgIDX.RegNum(k0)) = ...
		squeeze(cellSS{1}.SummarizedData{k0,1});
end

%---

%--- save resutl D
data=get(ArgData.D.hnd_MakeData, 'UserData');
data.ResultMatrix = Dat;
data.DataTags = Dtg;
data.Header1 = cellSS{1}.AnaFiles{1};
data.ExeData = cellSS{1}.ExeData;
set(ArgData.D.hnd_MakeData, 'UserData', data);
%-----------------

sub_Update_DataParmGUIs(ArgData);




%==========================================================================
%==== sub routines
%==========================================================================

%==========================================================================
function sub_Update_DataParmGUIs(ARG)
%==========================================================================
D=get(ARG.D.hnd_MakeData,'UserData');
set(ARG.D.hndSet1,'visible','on');
set(ARG.D.hndDataSelectListbox.(mytag('lbx_File')),'String',unique(D.DataTags.filename));
% set(ARG.D.hndDataSelectListbox.(mytag('lbx_Kind')),'String',{'Oxy','Deoxy','Total'});
set(ARG.D.hndDataSelectListbox.(mytag('lbx_Channel')),'String',1:size(D.ResultMatrix,2));
% set(ARG.D.hndDataSelectListbox.(mytag('lbx_Stim')),'String',unique(D.DataTags.Stim));
%--- add mu
str_HbKind = {'Oxy','Deoxy','Total'};
set(ARG.D.hndDataSelectListbox.(mytag('ppm_Kind')),'String',str_HbKind{D.ExeData.AD.selectHbKind});
mstr = unique(D.DataTags.Stim);
mstr{end+1} = 'All';
set(ARG.D.hndDataSelectListbox.(mytag('ppm_Stim')),'String',mstr);
set(ARG.D.hndDataSelectListbox.(mytag('ppm_Stim')),'Value',length(mstr));
%---


%==========================================================================
function D = sub_SaveGUIHandlesToD(hs)
%==========================================================================
D.hnd_MakeData = hs.(mytag('btn_MakeData'));


%==========================================================================
function Dtg = sub_alloc_Dtg(n)
%==========================================================================
Dtg.filename = cell(1,n);
Dtg.Kind = zeros(1,n);
Dtg.Stim = cell(1,n);
Dtg.RegNum = zeros(1,n);


%==========================================================================
function [DtgIDX,sz] = sub_DtgValue2DtgIDX(Dtg)
%==========================================================================
M = fieldnames(Dtg);
n = length(Dtg.(M{1}));
sz = zeros(1,length(M));
for k = 1:length(M)
	DtgIDX.(M{k}) = zeros(1,n);
	tmp = Dtg.(M{k});
	if ~isstr(tmp{1})
		tmp=cell2mat(tmp);
	end
	items = unique(tmp);
	sz(k) = length(items);%- items length
	for k1 = 1:length(items)
		if iscell(items)
			DtgIDX.(M{k})( strcmp(items{k1},tmp) ) = k1;
		else
			DtgIDX.(M{k})( tmp == items(k1) ) = k1;
		end
	end
end


%==========================================================================
function [hs, newHS, p] = sub_MakeGUI_Editbox(hs, Name, Def_String, Label_String, p, dp)
%==========================================================================
newHS=[];
[prop,prop_t] = sub_sub_Get_Base_Properties(hs.figure1);
lblDY=11;

tag=mytag(['edt_' Name]);
hs.(tag)=uicontrol(hs.figure1,prop{:},'TAG',tag,...
	'style','edit','BackgroundColor',[1 1 1],...
	'HorizontalAlignment','left',...
	'String',Def_String,...
	'Position',[p(1) p(2)-p(4)+lblDY p(3) p(4)-lblDY]);
newHS(end+1)=hs.(tag);

tag=mytag(['txt_' Name '_Label']);
hs.(tag)=uicontrol(hs.figure1,prop_t{:},'TAG',tag,...
	'String',Label_String,...
	'Position',[p(1) p(2) p(3) lblDY]);
newHS(end+1)=hs.(tag);
p(1) = p(1)+dp(1); p(2) = p(2)-dp(2);


%==========================================================================
function [hs, newHS, p] = sub_MakeGUI_Listbox(hs, Name, Def_String, Def_Value, Label_String, p, dp)
%==========================================================================
newHS=[];
[prop,prop_t] = sub_sub_Get_Base_Properties(hs.figure1);
lblDY = 11;

tag=mytag(['txt_' Name '_Label']);
hs.(tag)=uicontrol(hs.figure1,prop_t{:},'TAG',tag,...
	'String',Label_String,...
	'Position',[p(1) p(2) p(3) lblDY]);
newHS(end+1)=hs.(tag);

tag=mytag(['lbx_' Name]);
hs.(tag)=uicontrol(hs.figure1,prop{:},'TAG',tag,...
	'style','listbox','BackgroundColor',[1 1 1],...
	'HorizontalAlignment','left','max',100,'ListboxTop',1,...
	'String',Def_String,'Value', Def_Value,...
	'Position',[p(1) p(2)-p(4)+lblDY p(3) p(4)-lblDY]);
set(hs.(tag),'Listboxtop',1);
newHS(end+1)=hs.(tag);
p(1) = p(1)+dp(1); p(2) = p(2)-dp(2);


%==========================================================================
function [hs, newHS, p] = sub_MakeGUI_Popupmenu(hs, Name, Def_String, Def_Value, Label_String, p, dp)
%==========================================================================
newHS=[];
[prop,prop_t] = sub_sub_Get_Base_Properties(hs.figure1);
lblDY = 11;

tag=mytag(['txt_' Name '_Label']);
hs.(tag)=uicontrol(hs.figure1,prop_t{:},'TAG',tag,...
	'String',Label_String,...
	'Position',[p(1) p(2) p(3) lblDY]);
newHS(end+1)=hs.(tag);

tag=mytag(['ppm_' Name]);
hs.(tag)=uicontrol(hs.figure1,prop{:},'TAG',tag,...
	'style','popupmenu','BackgroundColor',[1 1 1],...
	'HorizontalAlignment','left',...
	'String',Def_String,'Value', Def_Value(1),...
	'Position',[p(1) p(2)-p(4)+lblDY p(3) p(4)-lblDY]);
newHS(end+1)=hs.(tag);
p(1) = p(1)+dp(1); p(2) = p(2)-dp(2);


%==========================================================================
function [hs, newHS, p] = sub_MakeGUI_Checkbox(hs, Name, Def_Value, Label_String, p,dp)
%==========================================================================
newHS=[];
[dummy,prop_t] = sub_sub_Get_Base_Properties(hs.figure1);

tag=mytag(['cbx_' Name]);
hs.(tag)=uicontrol(hs.figure1,prop_t{3:end},'TAG',tag,...
	'style','checkbox','String',Label_String,'Value',Def_Value,...
	'Position',p);
newHS(end+1)=hs.(tag);
p(1) = p(1)+dp(1); p(2) = p(2)-dp(2);


%==========================================================================
function [hs, newHS, p] = sub_MakeGUI_Button(hs, Name, CallbackString, Label_String, p,dp)
%==========================================================================
newHS=[];
[dummy,prop_t] = sub_sub_Get_Base_Properties(hs.figure1);
tag=mytag(['btn_' Name]);
hs.(tag)=uicontrol(hs.figure1,prop_t{3:end},'TAG',tag,...
	'style','pushbutton','String',Label_String,...
	'Callback', CallbackString, 'Position',p);
newHS(end+1)=hs.(tag);
p(1) = p(1)+dp(1); p(2) = p(2)-dp(2);


%==========================================================================
function [hs, newHS] = sub_MakeGUI_Checkbox2(hs, Name, Def_Value, Label_String, p)
%==========================================================================
newHS=[];
[dummy,prop_t] = sub_sub_Get_Base_Properties(hs.figure1);

tag=mytag(['cbx_' Name]);
hs.(tag)=uicontrol(hs.figure1,prop_t{3:end},'TAG',tag,...
	'style','checkbox','String','','Value',Def_Value,...
	'Position',p);
newHS(end+1)=hs.(tag);

tag=mytag(['txt_' Name '_Label']);
cbstr = sprintf('hs=guidata(gcf);v=get(hs.%s,''value'');set(hs.%s,''value'',(v==0))',tag,tag);
hs.(tag)=uicontrol(hs.figure1,prop_t{:},'TAG',tag,'String',Label_String,...
	'Position',[p(1)+20 p(2) p(3) p(4)/2],'ButtonDownFcn',cbstr);
newHS(end+1)=hs.(tag);


%==========================================================================
function [hs, newHS, p] = sub_MakeGUI_Frame(hs, Name, Label_String, p, dp)
%==========================================================================
newHS=[];
[prop,prop_t] = sub_sub_Get_Base_Properties(hs.figure1);
lblDY = 11;

tag=mytag(['frm_' Name '_Label']);
hs.(tag)=uicontrol(hs.figure1,prop_t{:},'TAG',tag,...
	'String',Label_String,...
	'Position',[p(1) p(2) p(3) lblDY]);
newHS(end+1)=hs.(tag);

tag=mytag(['frm_' Name]);
hs.(tag)=uicontrol(hs.figure1,prop{:},'TAG',tag,...
	'style','frame','String',Label_String,...
	'Position',[p(1) p(2)-p(4)+lblDY p(3) p(4)-lblDY]);
newHS(end+1)=hs.(tag);
p(1) = p(1)+dp(1); p(2) = p(2)-dp(2);


%==========================================================================
function [prop,prop_t,c]=sub_sub_Get_Base_Properties(figH)
%==========================================================================
c=get(figH,'Color');
prop={'Units','pixels','Visible','off'};
prop_t={prop{:},'style','text','HorizontalAlignment','left','BackgroundColor',c};
